<?php

namespace App\Tests;

use PHPUnit\Framework\Assert;
use Symfony\Component\Filesystem\Filesystem;

class TestFileHelper
{
    private const LEGACY_DIRECTORY = __DIR__ . '/../legacy';

    public static function createLegacyDirectoryIfNecessary(Assert $testCase): void
    {
        $fileSystem = new Filesystem();
        if (!$fileSystem->exists(self::LEGACY_DIRECTORY)) {
            $fileSystem->mkdir(self::LEGACY_DIRECTORY, 0644);
        }
        $testCase->assertTrue(
            $fileSystem->exists(self::LEGACY_DIRECTORY),
            'The directory \'' . self::LEGACY_DIRECTORY . '\' should exists'
        );
    }
}
